/*******************************************************************************
 *
 * File Name: neuralNetworkFormation.h
 * Author: Richard Baxter
 * Project: Advanced Neural Network (ANN) - Fractal Based Neural Network
 * Project Version: 1b13d 29-Sept-07
 * Comments:
 *
 *******************************************************************************/

//IMPORTANT CODING NOTE - on 10-dec-06/1b6b I have started to remove the neuronReference class as circular referencing does not appear to be allowed in C++
//NB when create NeuronList class change all referecnes to "...List->frontNeuronReferences.." to "...List->neuronReferences" as Neurons when declared for the purpose of creating neuron lists only have their frontNeuronReferences used

#include "neuronClass.h"


//these variables are only relevant for TEST_LEVEL_2_TH and TEST_LEVEL_4_TH
#define ADV_MEAN_NUMBER_OF_HIDDEN_LAYERS_TH 3;						/*this needs to be optimised - depends upon number of inputs/outputs*/
#ifdef ANN
	#define MEAN_SUBNET_DIVERGENCE_FACTOR_TH (2)
	#define MAX_NUM_RECURSIVE_SUBNETS_TH	(10)
#endif


#define USE_BASIC_SUBNET_DIVERGENCE


#define ABS_OF_SHORT 32767.0

void formSimpleNeuralNet(Neuron * firstInputNeuron, Neuron * firstOutputNeuron, long numberOfInputNeurons, long numberOfHiddenNeurons, long numberOfOutputNeurons);
Neuron * formNeuralNet(Neuron * firstInputNeuron, Neuron * firstOutputNeuron, long numberOfInputNeurons, long numberOfOutputNeurons, long meanNumberOfHiddenLayers);

#ifdef ANN
Neuron * formAdvancedNeuralNetwork(Neuron * firstInputNeuron, Neuron * firstOutputNeuron, long numberOfInputNeurons, long numberOfOutputNeurons, long meanNumberOfHiddenLayers, double meanSubnetDivergenceFactor, long maxNumberOfRecursiveSubnets);
#endif




