/*******************************************************************************
 *
 * File Name: neuralNetworkTraining.h
 * Author: Richard Baxter
 * Project: Advanced Neural Network (ANN) - Fractal Based Neural Network
 * Project Version: 1b13d 29-Sept-07
 * Comments:
 *
 *******************************************************************************/

 //IMPORTANT CODING NOTE - on 10-dec-06/1b6b I have started to remove the neuronReference class as circular referencing does not appear to be allowed in C++
//NB when create NeuronList class change all referecnes to "...List->frontNeuronReferences.." to "...List->neuronReferences" as Neurons when declared for the purpose of creating neuron lists only have their frontNeuronReferences used

#include "neuronClass.h"



#define	MAX_NUM_FOLDS_TH 10
#define IRRELEVANT 0.0
#define	ACCEPTABLE_ERROR_RATE 0.01F
	//95% accuracy is defined as the acceptable error rate. no more epochs will be calculated once this is reached.
#define	MAX_NUMBER_OF_EPOCHS 500
#define ERROR_VARIATION_ALLOWED 0.002F










void THTrainNeuralNetwork(Neuron * firstInputNeuron, Neuron * firstOutputNeuron, int numberOfInputNeurons, int numberOfOutputNeurons, int maxFolds);

void storeNeuralNetworkBiasAndWeights(Neuron * firstInputNeuron, long numberOfInputNeurons);
void storeNeuronParentsBiasAndWeight(Neuron * neuronBeingAccessed);

void restoreNeuralNetworkWithStoredBiasAndWeights(Neuron * firstInputNeuron, long numberOfInputNeurons);
void restoreNeuronParentsWithStoredBiasAndWeight(Neuron * neuronBeingAccessed);

void resetNeuralNetworkWithRandomBiasAndWeights(Neuron * firstInputNeuron, long numberOfInputNeurons);
void resetNeuronParentsWithRandomBiasAndWeight(Neuron * neuronBeingAccessed);

void resetInputsAndClassTargets(Neuron * firstInputNeuron, Neuron * firstOutputNeuron, long numberOfInputNeurons, long numberOfOutputNeurons, int testSegment);

float calculateStandardDeviation(float* array, int length, float average);



